CARGO-PUBLISH(1)

NAME
cargo-publish - Upload a package to the registry

SYNOPSIS

cargo package [OPTIONS]

DESCRIPTION

This command will create a distributable, compressed .crate file with the source code of the package in the current directory and upload it to a registry. The default registry is This performs the following steps:

    1. Performs a few checks, including:

        • No [patch] sections are allowed in the manifest.

        • Checks the package.publish key in the manifest for restrictions on which registries you are allowed to publish to.

    2. Create a .crate file by following the steps in cargo-package(1).

    3. Upload the crate to the registry. Note that the server will perform additional checks on the crate.

This command requires you to be authenticated with either the --token option or using cargo-login(1).

See for more details about packaging and publishing.

OPTIONS

  Publish Options

--dry-run
    Perform all checks without uploading.

--token TOKEN
    API token to use when authenticating.

--no-verify
    Don’t verify the contents by building them.

--allow-dirty
    Allow working directories with uncommitted VCS changes to be packaged.

--index INDEX
    The URL of the registry index to use.

--registry REGISTRY
    Alternative registry to use.

    This option is unstable and available only on the nightly channel and requires the -Z unstable-options flag to enable.

  Compilation Options

--target TRIPLE
    Publish for the given architecture. The default is the host architecture. The general format of the triple is <arch><sub>-<vendor>-<sys>-<abi>. Run rustc --print target-list for a list of supported targets.

    This may also be specified with the build.target

--target-dir DIRECTORY
    Directory for all generated artifacts and intermediate files. May also be specified with the CARGO_TARGET_DIR environment variable, or the build.target-dir Defaults to target in the root of the workspace.

  Feature Selection

When no feature options are given, the default feature is activated for every selected package.

--features FEATURES
    Space or comma separated list of features to activate. These features only apply to the current directory’s package. Features of direct dependencies may be enabled with <dep-name>/<feature-name> syntax.

--all-features
    Activate all available features of all selected packages.

--no-default-features
    Do not activate the default feature of the current directory’s package.

  Manifest Options

--manifest-path PATH
    Path to the Cargo.toml file. By default, Cargo searches in the current directory or any parent directory for the Cargo.toml file.

--frozen, --locked
    Either of these flags requires that the Cargo.lock file is up-to-date. If the lock file is missing, or it needs to be updated, Cargo will exit with an error. The --frozen flag also prevents Cargo from attempting to access the network to determine if it is out-of-date.

    These may be used in environments where you want to assert that the Cargo.lock file is up-to-date (such as a CI build) or want to avoid network access.

  Miscellaneous Options

-j N, --jobs N
    Number of parallel jobs to run. May also be specified with the build.jobs Defaults to the number of CPUs.

  Display Options

-v, --verbose
    Use verbose output. May be specified twice for "very verbose" output which includes extra output such as dependency warnings and build script output. May also be specified with the term.verbose

-q, --quiet
    No output printed to stdout.

--color WHEN
    Control when colored output is used. Valid values:

        • auto (default): Automatically detect if color support is available on the terminal.

        • always: Always display colors.

        • never: Never display colors.

    May also be specified with the term.color

  Common Options

-h, --help
    Prints help information.

-Z FLAG...
    Unstable (nightly-only) flags to Cargo. Run cargo -Z help for details.

ENVIRONMENT

See for details on environment variables that Cargo reads.

EXIT STATUS

0
    Cargo succeeded.

101
    Cargo failed to complete.

EXAMPLES

    1. Publish the current package:

        cargo publish

SEE ALSO

cargo(1), cargo-package(1), cargo-login(1)